(function(window, $) {
    $(function() {
        bEffectSlide = function() {
            this.wrap = null;
            this.list = null;
            this.effect = 'coverflow';
            this.animation = false;
            this.current = 0;
            this.swiper = null;
            return this.init();
        };
        bEffectSlide.prototype = {
            //初期化処理
            init: function() {
                this.wrap = $("#coverWrap");
                this.list = this.wrap.find('>*');
                this.loaded = 0;
                this.length = this.list.length;

                $(document).trigger("bCoverReady");

                return this;
            },
            setPosition: function() {
                return this;
            },
            start: function() {
                var self = this;
                var defer = $.Deferred();
                var sid = null;

                self.setPosition();

                this.list.find('img').each(function() {
                    if (0 < $(this).height()) {
                        self.loaded++;
                    } else {
                        $(this).on('load', function() {
                            self.loaded++;
                        });
                    }
                });

                sid = setInterval(function() {
                    if (self.loaded == self.length) {
                        defer.resolve();
                    }
                }, 10);

                defer.promise().done(function() {
                    clearInterval(sid);
                    self.list.each(function() {
                        var src = $(this).find('img').attr('src');
                        $(this).addClass('swiper-slide');
                        $(this).css({
                            backgroundImage: 'url(' + src + ')'
                        });
                        // $(this).find('img').hide();
                    });

                    this.current = self.length;
                    if (1 < self.list.length) {
                        self.slide();
                    }
                    
                    if (1 == self.list.length) {
                        setTimeout(function(){
                            self.wrap.width(self.wrap.width());
                            self.wrap.width('100%');             
                        }, 500);
                    }
                });
                
                window.bEffects = this;

                return this;
            },
            reset: function() {
                this.wrap = $("#coverWrap");
                this.list = this.wrap.find('>*');
                this.length = this.list.length;
                this.loaded = this.length;

                this.list.each(function() {
                    var src = $(this).find('img').attr('src');
                    $(this).addClass('swiper-slide');
                    $(this).css({
                        backgroundImage: 'url(' + src + ')'
                    });
                    $(this).find('img').hide();
                });

                if (1 < this.list.length) {
                    this.slide();
                    this.wrap.next().show();
                } else {
                    this.wrap.css({transform: ''});
                    this.wrap.next().hide();
                }

                return this;
            },
            stop: function() {
                if (this.swiper) {
                    this.swiper.destroy();
                    this.swiper = null;
                }
                
                return this;
            },
            slide: function(zero, reverse) {
                var self = this;
                this.swiper = new Swiper('#coverList', {
                    pagination: '.swiper-pagination-cover',
                    paginationClickable: false,
                    autoplay: cover_interval,
                    speed: cover_duration,
                    effect: self.effect,
                    slidesPerView: 1,
                    nextButton: '.swiper-button-next-cover',
                    prevButton: '.swiper-button-prev-cover',
                    autoplayDisableOnInteraction: false,
                    loop: true,
                    onImagesReady: function(_swiper) {
                        var max = 0;
                        $(self.wrap).find('.swiper-slide').find('img').each(function() {
                            max = Math.max(max, $(this).height());
                        });
                        max = Math.min(max, $(self.wrap).height());
                        $(self.wrap).parent().height(max);
                        $(self.wrap).parent().data('defaultHeight', max);
                        _swiper.update('reset');
                    }
                });

                $(window).on("orientationchange", function() {
                    setTimeout(function(){
                        var max = 0;
                        $(self.wrap).parent().height('auto');
                        $(self.wrap).find('.swiper-slide').find('img').show();
                        $(self.wrap).find('.swiper-slide').find('img').each(function() {
                            max = Math.max(max, $(this).height());
                        });
                        max = Math.min(max, $(self.wrap).height());
                        $(self.wrap).parent().height(max);
                        $(self.wrap).parent().data('defaultHeight', max);
                        self.swiper.destroy();
                        setTimeout(function(){
                            self.slide();
                        }, 20);
                    }, 10);
                });
            }
        };

        window.bEffectSlide = new bEffectSlide();
    });

})(window, jQuery);